现在的位置: 首页 > 综合 > 正文

【字典树+DFS】 hdu1298 T9

2018年01月14日 ⁄ 综合 ⁄ 共 5289字 ⁄ 字号 评论关闭


T9

http://acm.hdu.edu.cn/showproblem.php?pid=1298


Problem Description
A while ago it was quite cumbersome to create a message for the Short Message Service (SMS) on a mobile phone. This was because you only have nine keys and the alphabet has more than nine letters, so most characters could only be entered by pressing one key
several times. For example, if you wanted to type "hello" you had to press key 4 twice, key 3 twice, key 5 three times, again key 5 three times, and finally key 6 three times. This procedure is very tedious and keeps many people from using the Short Message
Service.

This led manufacturers of mobile phones to try and find an easier way to enter text on a mobile phone. The solution they developed is called T9 text input. The "9" in the name means that you can enter almost arbitrary words with just nine keys and without pressing
them more than once per character. The idea of the solution is that you simply start typing the keys without repetition, and the software uses a built-in dictionary to look for the "most probable" word matching the input. For example, to enter "hello" you
simply press keys 4, 3, 5, 5, and 6 once. Of course, this could also be the input for the word "gdjjm", but since this is no sensible English word, it can safely be ignored. By ruling out all other "improbable" solutions and only taking proper English words
into account, this method can speed up writing of short messages considerably. Of course, if the word is not in the dictionary (like a name) then it has to be typed in manually using key repetition again.


Figure 8: The Number-keys of a mobile phone.

More precisely, with every character typed, the phone will show the most probable combination of characters it has found up to that point. Let us assume that the phone knows about the words "idea" and "hello", with "idea" occurring more often. Pressing the
keys 4, 3, 5, 5, and 6, one after the other, the phone offers you "i", "id", then switches to "hel", "hell", and finally shows "hello".

Write an implementation of the T9 text input which offers the most probable character combination after every keystroke. The probability of a character combination is defined to be the sum of the probabilities of all words in the dictionary that begin with
this character combination. For example, if the dictionary contains three words "hell", "hello", and "hellfire", the probability of the character combination "hell" is the sum of the probabilities of these words. If some combinations have the same probability,
your program is to select the first one in alphabetic order. The user should also be able to type the beginning of words. For example, if the word "hello" is in the dictionary, the user can also enter the word "he" by pressing the keys 4 and 3 even if this
word is not listed in the dictionary.

 


Input
The first line contains the number of scenarios.

Each scenario begins with a line containing the number w of distinct words in the dictionary (0<=w<=1000). These words are given in the next w lines. (They are not guaranteed in ascending alphabetic order, although it's a dictionary.) Every line starts with
the word which is a sequence of lowercase letters from the alphabet without whitespace, followed by a space and an integer p, 1<=p<=100, representing the probability of that word. No word will contain more than 100 letters.

Following the dictionary, there is a line containing a single integer m. Next follow m lines, each consisting of a sequence of at most 100 decimal digits 2-9, followed by a single 1 meaning "next word".

 


Output
The output for each scenario begins with a line containing "Scenario #i:", where i is the number of the scenario starting at 1.

For every number sequence s of the scenario, print one line for every keystroke stored in s, except for the 1 at the end. In this line, print the most probable word prefix defined by the probabilities in the dictionary and the T9 selection rules explained above.
Whenever none of the words in the dictionary match the given number sequence, print "MANUALLY" instead of a prefix.

Terminate the output for every number sequence with a blank line, and print an additional blank line at the end of every scenario.

 


Sample Input
2 5 hell 3 hello 4 idea 8 next 8 super 3 2 435561 43321 7 another 5 contest 6 follow 3 give 13 integer 6 new 14 program 4 5 77647261 6391 4681 26684371 77771
 


Sample Output
Scenario #1: i id hel hell hello i id ide idea Scenario #2: p pr pro prog progr progra program n ne new g in int c co con cont anoth anothe another p pr MANUALLY MANUALLY

题意:模拟手机键盘,给你一个字典,里面是单词和这个单词出现的频率。之后给你一个数字串,代表手机上的按键,让你把每次按键最可能(即频率最高,相同频率输出字典序最小的)的字符串输出来。ps:出现的前缀的频率要累加,例:abc 4 ab 3 则a 7 b 7 c 4

题解:按字母建立字典树(不能按数字建立,原因应该是一个数字映射多个字母,在之后的统计中会出错),然后再在字典树上搜索最大值即可。

#include<cstdio>
#include<cstring>
using namespace std;
int mat[10][5]= {{},{},{0,1,2},{3,4,5},{6,7,8},{9,10,11},{12,13,14},{15,16,17,18},{19,20,21},{22,23,24,25}};//映射
char res[105],temp[105];
int maxx;//最大值
struct node
{
    node *next[26];
    int id;
    node()//构造函数
    {
        memset(next,0,sizeof(next));
        id=0;
    }
}*head;
void build(char *s,node *head,int id)//建立字典树
{
    int len=strlen(s),k;
    for(int i=0; i<len; ++i)
    {
        k=s[i]-'a';
        if(head->next[k]==NULL)
            head->next[k]=new node();
        head->next[k]->id+=id;
        head=head->next[k];
    }
}
void dfs(char *s,node *head,int pos,int l)
{
    if(pos==l)//到达目标长度
    {
        if(head->id>maxx)
        {
            maxx=head->id;
            strcpy(res,temp);
        }
        return;
    }
    int k=s[pos+1]-'0';
    int len=((k==7||k==9)?4:3);
    for(int i=0;i<len;++i)
    {
        int x=mat[k][i];
        if(head->next[x]==NULL) continue;
        temp[pos+1]=(char)('a'+x);
        temp[pos+2]='\0';//清除上次搜索的痕迹
        dfs(s,head->next[x],pos+1,l);
    }
}
void f(node *head)//释放申请的内存
{
    for(int i=0; i<26; ++i)
        if(head->next[i]!=NULL)
            f(head->next[i]);
    delete head;
}
int main()
{
    int cas,n,m,id;
    char s[105];
    scanf("%d",&cas);
    for(int tt=1; tt<=cas; ++tt)
    {
        head=new node();
        printf("Scenario #%d:\n",tt);
        scanf("%d",&n);
        for(int i=0; i<n; ++i)
        {
            scanf("%s%d",s,&id);
            build(s,head,id);
        }
        scanf("%d",&m);
        for(; m--;)
        {
            scanf("%s",s);
            if(s[0]=='1')
            {
                puts("");
                continue;
            }
            else
            {

                int len = strlen(s);
                for(int i=0; s[i]!='1'; ++i)
                {
                    maxx=-1;
                    dfs(s,head,-1,i);
                    if(maxx!=-1) printf("%s\n",res);
                    else puts("MANUALLY");
                }
                puts("");
            }
        }
        puts("");
        f(head);
    }
    return 0;
}

来源:http://blog.csdn.net/ACM_Ted

抱歉!评论已关闭.